# kubeadm-upgrade
This script is specially written for upgrading a kubernetes cluster from 1.9 version to 1.12 version.
Normal upgrade from 1.9 to 1.12 is not straightforward , we need to upgrade the cluster to intermediate version then
we can upgrade the cluster to 1.12. This script is designed to achieve that path. Details steps are as follows.

In order to install this script please run the following code on each node(both master and worker).Make sure you have all the images
(1.10, 1.11 and 1.12 in the repo.

```
yum install -y kubeadm-upgrade
export KUBE_REPO_PREFIX=k8s_registry
```
Upgrading Master Node:
1. Stop your cluster: kubeadm-setup.sh stop
2. Backup your cluster: kubeadm-upgrade.sh backup /backup_location
3. Restart the cluster: kubeadm-setup.sh restart
4. Run upgrade script on the master: kubeadm-upgrade.sh upgrade
5. If fails please try to restore the cluster: kubeadm-upgrade.sh restore  /backup_location/master-backup-v1.9.xxxxxxxxxxxx.tar 
   This step will revert back to previous state.

Upgrading worker node:
1. First drain the worker node , run the command from master node:  kubectl drain $worker_node --ignore-daemonsets
2. Check the worker node status( kubectl get nodes) from master node status should be SchedulingDisabled. ["A node that has been drained should have its status set to SchedulingDisabled."]
3. Now run the upgrade command from worker node: kubeadm-upgrade.sh upgrade
4. After the upgrade command completes successfully. uncordon the worker node. Run "kubectl uncordon $worker_node" from master node

# Upgrade log can be found in the following directory:
/var/log/kubeadm-upgrade
Example:
```
[root@k8s-w kubeadm-upgrade]# pwd
/var/log/kubeadm-upgrade
[root@k8s-w kubeadm-upgrade]# ls
k8s-upgrade-2018-12-13-23:39:17.log  k8s-upgrade-2018-12-14-00:32:53.log
[root@k8s-w kubeadm-upgrade]#
```
# Now check the health of the cluster.
```
kubectl get nodes
kubectl get po
run performance and other tests to see if the cluster looks good.
```
